Ext.ns('app.xmlrpc');

/**
 * @class app.xmlrpc.Value
 * Represents a typed value to be sent as an XML RPC parameter.
 */
app.xmlrpc.Value = Ext.extend(Object, {
	/**
	 * @cfg {String} type
	 * The datatype. Defaults to string.
	 */
	type: 'string', 
	
	/**
	 * @cfg {Mixed} value
	 * The raw value.
	 */
	value: undefined, 
	
	constructor: function(config) {
		Ext.apply(this, config);
		app.xmlrpc.Value.superclass.constructor.call(this, config);
	}
});
